## netkit-telnet-ssl-0.17.24+0.1.tar.bz2

=== Makefile ===
# You can do "make SUB=blah" to make only a few, or edit here, or both
# You can also run make directly in the subdirs you want.

SUB =   libtelnet telnet telnetd telnetlogin

%.build:
	(cd $(patsubst %.build, %, $@) && $(MAKE))

%.install:
	(cd $(patsubst %.install, %, $@) && $(MAKE) install)

%.clean:
	(cd $(patsubst %.clean, %, $@) && $(MAKE) clean)

all:     $(patsubst %, %.build, $(SUB))
install: $(patsubst %, %.install, $(SUB))
clean:   $(patsubst %, %.clean, $(SUB))

distclean: clean
	rm -f MCONFIG

=== telnet/Makefile ===
all: telnet

include ../MCONFIG
include ../MRULES

#CXXFLAGS:=$(patsubst -O2, -g, $(CXXFLAGS))

# -DAUTHENTICATE
CXXFLAGS += -DUSE_TERMIO -DKLUDGELINEMODE -DAUTHENTICATE -DUSE_SSL \
	-I/usr/include/openssl -I../
LIBTELNET = ../libtelnet/libtelnet.a 
LIBS += $(LIBTERMCAP) $(LIBTELNET) -lssl -lcrypto

SRCS = commands.cc main.cc network.cc ring.cc sys_bsd.cc telnet.cc \
	terminal.cc tn3270.cc utilities.cc genget.cc environ.cc netlink.cc \
	glue.cc glue2.cc

OBJS = $(patsubst %.cc, %.o, $(SRCS))

telnet: $(OBJS) $(LIBTELNET)
	$(CXX) $(LDFLAGS) $^ $(LIBS) -o $@

include depend.mk
depend:
	$(CXX) $(CXXFLAGS) -MM $(SRCS) >depend.mk

install: telnet
	install -m$(BINMODE) telnet $(INSTALLROOT)$(BINDIR)/telnet-ssl
	install -m$(MANMODE) telnet.1 $(INSTALLROOT)$(MANDIR)/man1/telnet-ssl.1

clean:
	rm -f *.o telnet

=== telnetd/Makefile ===
all: telnetd

include ../MCONFIG
include ../MRULES

# -DAUTHENTICATE

# If having unused tty devices root.root and mode 600 bugs you,
# take out -DPARANOID_TTYS.

CFLAGS += '-DISSUE_FILE="/etc/issue.net"' -DPARANOID_TTYS \
	   -DNO_REVOKE -DKLUDGELINEMODE -DDIAGNOSTICS -DAUTHENTICATE \
	   -DLOGIN_WRAPPER=\"/usr/lib/telnetlogin\" \
	   -DUSE_SSL -I/usr/include/openssl -I..
LIBTELNET = ../libtelnet/libtelnet.a 
LIBS += $(LIBTERMCAP) $(LIBTELNET) -lssl -lcrypto

OBJS = telnetd.o state.o termstat.o slc.o sys_term.o utility.o \
	global.o setproctitle.o

# authenc.o (empty)

# logout.o logwtmp.o (now from -lutil)


telnetd: $(OBJS) $(LIBTELNET)
	$(CC) $(LDFLAGS) $^ $(LIBS) -o $@

$(OBJS): defs.h ext.h pathnames.h telnetd.h logwtmp.h logout.h setproctitle.h
telnetd.o: ../version.h

install: telnetd
	install -m$(DAEMONMODE) telnetd $(INSTALLROOT)$(SBINDIR)/in.telnetd
	install -m$(MANMODE) issue.net.5 $(INSTALLROOT)$(MANDIR)/man5/
	install -m$(MANMODE) telnetd.8 $(INSTALLROOT)$(MANDIR)/man8/in.telnetd.8
	ln -sf in.telnetd.8 $(INSTALLROOT)$(MANDIR)/man8/telnetd.8

clean:
	rm -f *.o telnetd

=== debian/changelog ===
netkit-telnet-ssl (0.17.24+0.1-16) unstable; urgency=low

  * Fix inetd dependencies, thanks to Marco d'Itri (Closes: #402583).
    + Drop dependencies on netbase and update-inetd.
    + Add dependency on openbsd-inetd | inet-superserver.

 -- Ian Beckwith <ianb@nessie.mcc.ac.uk>  Wed, 13 Dec 2006 03:28:58 +0000

netkit-telnet-ssl (0.17.24+0.1-15) unstable; urgency=low

  * debian/control: add Depends: on update-inetd.

 -- Ian Beckwith <ianb@nessie.mcc.ac.uk>  Wed,  6 Dec 2006 05:56:34 +0000

netkit-telnet-ssl (0.17.24+0.1-14) unstable; urgency=medium

  * Changed telnetd-ssl.telnetd-ssl to telnetd-ssl in inetd configuration.
    Former format not supported by inetutils-inetd.
    Thanks to Alberto Gonzalez Iniesta.
    urgency=medium to try and get this fix in etch.
  * Install telnet README files in /usr/share/doc/telnet-ssl/
    (rather than /usr/share/doc/telnet/)

 -- Ian Beckwith <ianb@nessie.mcc.ac.uk>  Sat, 11 Nov 2006 17:11:42 +0000

netkit-telnet-ssl (0.17.24+0.1-13) unstable; urgency=low

  * Tweaked fix for #122763.
  * New telnet command: startssl - start SSL when talking
    to non-telnetds (eg imapd with STARTTLS) (Closes: #187202).
  * telnetd.postinst: configure: rewrite netkit-telnet's
    inetd entry if it still exists.
  * telnetd.8: add -z sslopt to options in SYNOPSIS.

 -- Ian Beckwith <ianb@nessie.mcc.ac.uk>  Sun, 24 Sep 2006 01:40:09 +0100

netkit-telnet-ssl (0.17.24+0.1-12) unstable; urgency=low

  * telnetd-ssl: Fixed segfault in netwritebuf() (Closes: #122763).
  * Added Christoph Martin to Uploaders:.

 -- Ian Beckwith <ianb@nessie.mcc.ac.uk>  Mon, 10 Jul 2006 02:37:20 +0100

netkit-telnet-ssl (0.17.24+0.1-11) unstable; urgency=low

  * Move telnetd.pem to /etc/telnetd-ssl (Closes: #368416):
  * Use private copy of openssl.cnf (from openssl_0.9.8b-2) (Closes: #372105).
  * Set Common Name to FQDN when generating certificate.
  * Standards-Version: 3.7.2 (No changes).

 -- Ian Beckwith <ianb@nessie.mcc.ac.uk>  Fri, 16 Jun 2006 19:10:02 +0100

netkit-telnet-ssl (0.17.24+0.1-10) unstable; urgency=low

  * telnet: don't disable ssl to localhost if -z secure
    is set (Closes: #339528, #339535).
  * Applied Justin Pryzby's netkit-telnet patch to reject invalid
    port numbers (See #300273).
  * Man page fixes:
    + telnet.1: formatting fix, thanks to Nicolas François (Closes: #357737).
    + issue.net.5: insert \& in %-sequences to stop groff interpreting them.

 -- Ian Beckwith <ianb@nessie.mcc.ac.uk>  Fri, 28 Apr 2006 20:13:02 +0100

netkit-telnet-ssl (0.17.24+0.1-9) unstable; urgency=low

  * Fixed socks problems, thanks to IWAMURO Motonori (Closes: #314416).
  * Dropped netbase as a dependency of telnet-ssl (Closes: #316946).
  * telnetd-ssl postinst/postrm changes:
    + Rename telnetd user to telnetd-ssl (Closes: #147945).
    + Made update-inetd regexps a bit more robust.
    + Added || true to rmdir calls in telnetd.post{inst,rm}.
    + Use colons to separate user and group in chown calls.
  * Bumped Standards-Version (No changes).
  * Switched to debhelper compat level 4.
  * Fixed warnings generated by gcc 4.

 -- Ian Beckwith <ianb@nessie.mcc.ac.uk>  Tue, 12 Jul 2005 02:07:26 +0100

netkit-telnet-ssl (0.17.24+0.1-8) unstable; urgency=low

  * Ack NMU. Thanks Joey Hess (Closes: #302036).
  * telnetd-ssl.postinst: create telnetd user with home
    dir of /nonexistant (See #272312).
  * telnetd/utility.c: wrap SSL_writev in #ifdef USE_SSL
    Thanks to Matt Bookman.

 -- Ian Beckwith <ianb@nessie.mcc.ac.uk>  Thu, 14 Apr 2005 16:55:29 +0100

netkit-telnet-ssl (0.17.24+0.1-7.1) unstable; urgency=HIGH

  * NMU
  * telnet/telnet.cc: Fixed buffer overflow in the handling of the
    LINEMODE suboptions in telnet clients (CAN-2005-0469).
    Thanks Martin 'Joey' Schulze for the patch.
    Closes: #302036

 -- Joey Hess <joeyh@debian.org>  Thu, 31 Mar 2005 11:09:56 -1000

netkit-telnet-ssl (0.17.24+0.1-7) unstable; urgency=low

  * telnetd.postrm: use "test -x" instead of "command -v" (Closes: #293052).
  * telnetd.{prerm,postinst}: use "test -x" before calls to update-inetd.

 -- Ian Beckwith <ianb@nessie.mcc.ac.uk>  Thu, 24 Feb 2005 20:09:31 +0000

netkit-telnet-ssl (0.17.24+0.1-6) unstable; urgency=high

  * Urgency high due to security fix
  * Fixed format string vulnerability discovered by Joel Eriksson
    [telnetd/telnetd.c, CAN-2004-0998]

 -- Ian Beckwith <ianb@nessie.mcc.ac.uk>  Tue, 21 Dec 2004 18:13:20 +0000

netkit-telnet-ssl (0.17.24+0.1-5) unstable; urgency=low

  * telnet:
    + Separate autologin and SSL (Closes: #57149, #57266, #59295, #62198, #83306).
    + Autologin now defaults to off (use -a to enable).
    + Verify server cert commonName matches remote hostname (Closes: #210749).
    + Enable -z authdebug (Closes: #145551).
    + Enable SSL when connecting from telnet> prompt (Closes: #26994).
    + Give better diagnostics and exit cleanly when SSL certificate verification fails.
    + Make -z verify=3 simulate -z certrequired.
  * telnetlogin:
    + added '-f username' option for preauthenticated login without password.
    + fixed logic of check_a_hostname.
  * telnetd:
    + Fix -z certsok (Closes: #36527).
    + set SSL_VERIFY_PEER if certsok enabled.
    + Add -N option to log IP addresses rather than perform reverse DNS lookups.
      Thanks to Dean Gaudet (Closes: #258371).
  * Support DEB_BUILD_OPTIONS.
  * Fixed compiler warnings.
  * Updated man pages.
  * debian/control: changed Priority: to extra.

 -- Ian Beckwith <ianb@nessie.mcc.ac.uk>  Sun,  5 Dec 2004 12:57:09 +0000

netkit-telnet-ssl (0.17.24+0.1-4) unstable; urgency=high

  * telnetd/utility.c: Fix remote DOS hole (CAN-2004-0911). Thanks Herbert Xu.

 -- Ian Beckwith <ianb@nessie.mcc.ac.uk>  Thu, 30 Sep 2004 20:23:02 +0100

netkit-telnet-ssl (0.17.24+0.1-3) unstable; urgency=low

  * New Maintainer (Closes: #260184)
  * telnet/commands.cc: Apply Josh Martin's patch to fix
    buffer overflow when $HOME is too big.
  * telnetd/issue.net.5: escaped hyphen.



=== debian/control ===
Source: netkit-telnet-ssl
Section: net
Priority: extra
Maintainer: Ian Beckwith <ianb@nessie.mcc.ac.uk>
Uploaders: Christoph Martin <christoph.martin@uni-mainz.de>
Standards-Version: 3.7.2
Build-Depends: debhelper (>=4), libncurses-dev, libssl-dev

Package: telnet-ssl
Architecture: any
Depends: ${shlibs:Depends}
Replaces: netstd
Conflicts: telnet, ssltelnet (<< 0.12)
Provides: telnet-client
Description: The telnet client with SSL encryption support
 The telnet command is used for interactive communication with another host
 using the TELNET protocol.
 .
 SSL telnet(d) replaces normal telnet(d) using SSL authentication and 
 encryption. It interoperates with normal telnet(d) in both directions.
 It checks if the other side is also talking SSL, if not it falls back
 to normal telnet protocol.
 .
 Advantages over normal telnet(d): Your passwords and the data you send
 will not go in cleartext over the line. Nobody can get it with 
 tcpdump or similar tools. With SSLtelnet you can also connect to
 https-server like https://www.netscape.com. Just do 
 'telnet www.netscape.com 443'

Package: telnetd-ssl
Architecture: any
Depends: adduser, base-files (>= 2.1.8), dpkg (>= 1.7.0), openbsd-inetd | inet-superserver, passwd, openssl (>= 0.9.2b), ${shlibs:Depends}
Replaces: netstd
Provides: telnet-server
Conflicts: suidmanager (<< 0.50), telnetd, ssltelnet (<< 0.12)
Description: The telnet server with SSL encryption support
 The in.telnetd program is a server which supports the DARPA telnet interactive
 communication protocol.
 .
 SSL telnet(d) replaces normal telnet(d) using SSL authentication and 
 encryption. It interoperates with normal telnet(d) in both directions.
 It checks if the other side is also talking SSL, if not it falls back
 to normal telnet protocol.
 .
 Advantages over normal telnet(d): Your passwords and the data you send
 will not go in cleartext over the line. Nobody can get it with 
 tcpdump or similar tools. With SSLtelnet you can also connect to
 https-server like https://www.netscape.com. Just do 
 'telnet www.netscape.com 443'

=== debian/rules ===
#!/usr/bin/make -f
# $Id: rules,v 1.5 2006-11-11 20:08:10 ianb Exp $
# Sample debian/rules that uses debhelper. GNU copyright 1997 by Joey Hess.

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

ifneq (,$(findstring noopt,$(DEB_BUILD_OPTIONS)))
	CONFIGUREARGS=--with-debug
else
	CONFIGUREARGS=
endif

build:
	dh_testdir

	if [ ! -f MCONFIG ]; then \
		./configure $(CONFIGUREARGS); \
		sed -e 's/^CFLAGS=\(.*\)$$/CFLAGS= -Ddebian -D_GNU_SOURCE -g \1/' \
		    -e 's/^CXXFLAGS=\(.*\)$$/CXXFLAGS= -Ddebian -D_GNU_SOURCE -g \1/' \
		    MCONFIG > MCONFIG.new; \
		mv MCONFIG.new MCONFIG; \
	fi
	$(MAKE)

clean:
	dh_testdir
	dh_testroot

	-$(MAKE) distclean
	rm -f debian/telnetd-ssl.dirs debian/telnetd-ssl.postinst debian/telnetd-ssl.postrm debian/telnetd-ssl.prerm

	dh_clean

install: build
	cp debian/telnetd.dirs debian/telnetd-ssl.dirs
	cp debian/telnetd.postinst debian/telnetd-ssl.postinst
	cp debian/telnetd.postrm debian/telnetd-ssl.postrm
	cp debian/telnetd.prerm debian/telnetd-ssl.prerm
	dh_testdir
	dh_testroot
	dh_clean -k
	dh_installdirs

	$(MAKE) -C telnet INSTALLROOT=`pwd`/debian/telnet-ssl MANDIR=/usr/share/man \
		install
#	mv debian/tmp/usr/bin/telnet debian/tmp/usr/bin/telnet.netkit
#	mv debian/tmp/usr/share/man/man1/telnet.1 \
#	   debian/tmp/usr/share/man/man1/telnet.netkit.1
	cp telnet/README debian/telnet-ssl/usr/share/doc/telnet-ssl/README.telnet
	cp telnet/README.old debian/telnet-ssl/usr/share/doc/telnet-ssl/README.telnet.old
	$(MAKE) -C telnetd INSTALLROOT=`pwd`/debian/telnetd-ssl \
		MANDIR=/usr/share/man install
	cp telnetlogin/telnetlogin.8 debian/telnetd-ssl/usr/share/man/man8
	cp telnetlogin/telnetlogin debian/telnetd-ssl/usr/lib
	cp debian/openssl.cnf debian/telnetd-ssl/etc/telnetd-ssl

# Build architecture-independent files here.
binary-indep: build install
# We have nothing to do by default.

# Build architecture-dependent files here.
binary-arch: build install
#	dh_testversion
	dh_testdir
	dh_testroot
	dh_installdocs
	dh_installexamples
	dh_installmenu
#	dh_installemacsen
#	dh_installinit
	dh_installcron
#	dh_installmanpages
#	dh_undocumented
	dh_installchangelogs ChangeLog
	dh_strip
	dh_compress
	dh_fixperms
	dh_installdeb
	dh_shlibdeps
	dh_gencontrol
#	dh_makeshlibs
	dh_md5sums
	dh_builddeb

source diff:                                                                  
	@echo >&2 'source and diff are obsolete - use dpkg-source -b'; false

binary: binary-indep binary-arch
.PHONY: build clean binary-indep binary-arch binary
